ncdisp('WeatherDataTampen.nc');

%Reading significant wave heights on site (Tampen)
Hs_T = ncread('WeatherDataTampen.nc','swh');
lat = double(ncread('WeatherDataTampen.nc','latitude'));
long = double(ncread('WeatherDataTampen.nc','longitude'));

%Reading wind in v and u direction on site (Tampen)
Wind_uT = ncread('WeatherDataTampen.nc','u100');
Wind_vT = ncread('WeatherDataTampen.nc','v100');

Wind_uT = Wind_uT(:);
Wind_vT = Wind_vT(:);

Wind_T = Wind_uT.^2 + Wind_vT.^2;
Wind_T = abs(round(Wind_T.^0.5));

ncdisp('WeatherDataGulen.nc');

%Reading wind in v and u direction in port (Gulen Industrihamn)
Hs_G = ncread('WeatherDataGulen.nc','swh');
lat_G = double(ncread('WeatherDataGulen.nc','latitude'));
long_G = double(ncread('WeatherDataGulen.nc','longitude'));

%Reading wind in v and u direction in port (Gulen Industrihamn)
Wind_uG = ncread('WeatherDataGulen.nc','u100');
Wind_vG = ncread('WeatherDataGulen.nc','v100');

Wind_uG = Wind_uG(:);
Wind_vG = Wind_vG(:);

Wind_G = Wind_uG.^2 + Wind_vG.^2;
Wind_G = abs(round(Wind_G.^0.5));


filename_G = 'Wind_G.csv';
filename_T = 'Wind_T.csv';
csvwrite(filename_G,Wind_G);
csvwrite(filename_T,Wind_T);