clear;
clc;

SizeOfWeatherData = 26404;
Stop_Time = SizeOfWeatherData; %stop time for simulation

SetNumberOfTurbines = [1:1:1]; % 11:2:21 22:5:52];
NumberOfCables = 1;
NumberTugs = 4;
NumberHLV = 1;
NumberAHTS = 4;
NumberCLV = 1;

Cost = zeros(1,length(SetNumberOfTurbines));
ScaleOfEconomy = zeros(1,length(SetNumberOfTurbines));
TimePerTurbineList = zeros(1,length(SetNumberOfTurbines));
TotCostTugs = zeros(Stop_Time,length(SetNumberOfTurbines));
TotCostHLV = zeros(Stop_Time,length(SetNumberOfTurbines));
TotCostAHTS = zeros(Stop_Time,length(SetNumberOfTurbines));
FixCostTugs = zeros(1,length(SetNumberOfTurbines));
VarCostTugs = zeros(1,length(SetNumberOfTurbines));
FixCostHLV = zeros(1,length(SetNumberOfTurbines));
VarCostHLV = zeros(1,length(SetNumberOfTurbines));
FixCostAHTS =  zeros(1,length(SetNumberOfTurbines));
VarCostAHTS = zeros(1,length(SetNumberOfTurbines));
FixCostCLV =  zeros(1,length(SetNumberOfTurbines));
VarCostCLV = zeros(1,length(SetNumberOfTurbines));
WaitForLift = zeros(1,length(SetNumberOfTurbines));
WaitForTow = zeros(1,length(SetNumberOfTurbines));
WaitForInstall = zeros(1,length(SetNumberOfTurbines));
WaitForCable = zeros(1,length(SetNumberOfTurbines));
WaitForAnchor = zeros(1,length(SetNumberOfTurbines));
WaitingMatrix = zeros(1,length(SetNumberOfTurbines));
WaitLiftTot = zeros(1,length(SetNumberOfTurbines));
WaitTowTot = zeros(1,length(SetNumberOfTurbines));
WaitInstallTot = zeros(1,length(SetNumberOfTurbines));
WaitAnchorTot = zeros(1,length(SetNumberOfTurbines));
WaitCableTot = zeros(1,length(SetNumberOfTurbines));



MarkovChainGulen()
SeaDataMatrixGulen()
MarkovChainTampen()
SeaDataMatrixTampen()

%Making a for loop running the simulation for a list of number of turbines
%

for i=1:length(SetNumberOfTurbines)
   
    NumberOfTurbines=SetNumberOfTurbines(i);
    
    load_system('ProjectFOWF');
    set_param('ProjectFOWF', 'StopTime', 'Stop_Time') %choosing simulation 
    ...stop time
    sim('ProjectFOWF');%start sim
    
    %Variable cost over time
    CostTugs = ans.CostTugs(:);
    CostHLV = ans.CostHLV(:);
    CostAHTS = ans.CostAHTS(:);
    CostCLV = ans.CostCLV(:);

    %Fixed cost over time
    FixedCostTugs = ans.FixedCostTugs(:);
    FixedCostHLV = ans.FixedCostHLV(:);
    FixedCostAHTS = ans.FixedCostAHTS(:);
    FixedCostCLV = ans.FixedCostCLV(:);
    
    %Total costs per vesseltype
    Tot_Tugs = CostTugs + FixedCostTugs;
    Tot_HLV = CostHLV + FixedCostHLV;
    Tot_AHTS = CostAHTS + FixedCostAHTS;
    Tot_CLV = CostCLV + FixedCostCLV;
    
    L_Tugs = Stop_Time-length(Tot_Tugs);
    List_Tugs = zeros(L_Tugs,1);
    List_Tugs(:) = max(Tot_Tugs);
    Tot_Tugs_List = [Tot_Tugs;List_Tugs];
    
    L_HLV = Stop_Time-length(Tot_HLV);
    List_HLV = zeros(L_HLV,1);
    List_HLV(:) = max(Tot_HLV);
    Tot_HLV_List = [Tot_HLV;List_HLV];
    
    L_AHTS = Stop_Time-length(Tot_AHTS);
    List_AHTS = zeros(L_AHTS,1);
    List_AHTS(:) = max(Tot_AHTS);
    Tot_AHTS_List = [Tot_AHTS;List_AHTS];
    
    L_CLV = Stop_Time-length(Tot_CLV);
    List_CLV = zeros(L_CLV,1);
    List_CLV(:) = max(Tot_CLV);
    Tot_CLV_List = [Tot_CLV;List_CLV];
    
    
    
    %List of total cost per vesseltype
    TotCostTugs(:,i) = Tot_Tugs_List;
    TotCostHLV(:,i) = Tot_HLV_List;
    TotCostAHTS(:,i) = Tot_AHTS_List;
    TotCostCLV(:,i) = Tot_CLV_List;
    
    

    %Total fixed and variable costs per vesseltype
    max_FixTugs = max(FixedCostTugs);
    max_VarTugs = max(CostTugs);
    max_FixHLV = max(FixedCostHLV);
    max_VarHLV = max(CostHLV);
    max_FixAHTS =  max(FixedCostAHTS);
    max_VarAHTS = max(CostAHTS);
    max_FixCLV =  max(FixedCostCLV);
    max_VarCLV = max(CostCLV);
    
    %List of fixed and variable costs per vesseltype
    FixCostTugs(i) = max(FixedCostTugs);
    VarCostTugs(i) = max(CostTugs);
    FixCostHLV(i) = max(FixedCostHLV);
    VarCostHLV(i) = max(CostHLV);
    FixCostAHTS(i) =  max(FixedCostAHTS);
    VarCostAHTS(i) = max(CostAHTS);
    FixCostCLV(i) =  max(FixedCostCLV);
    VarCostCLV(i) = max(CostCLV);
    
    %Calculating total cost for different number of turbines
    Tot_MaxCost = max_FixTugs + max_VarTugs + max_FixHLV + max_VarHLV + ...
        max_FixAHTS + max_VarAHTS + max_FixCLV + max_VarCLV;
    
    Cost(i) = (Tot_MaxCost); 
    
    %Calculating the cost per turbine (unit-cost)
    ScaleOfEconomy(i) = (Cost(i)/i);
    
    %Total time divided by number of turbines (time per unit)
    Time = max(ans.Time(:));
    TimePerTurbine = Time/i;
    
    TimePerTurbineList(i) = TimePerTurbine;
    
    %TOTAL WAITING FOR WEATHER TIME PER TURBINE
    %Calculating the waiting time
    LiftStart = ans.Time_LiftingStart(:);
    ReadyLift = ans.Time_ReadyForLifting(:);
    WaitLift = LiftStart - ReadyLift;
    WaitLiftTot(i) = sum(WaitLift);
    WaitForLift(i) = sum(WaitLift)/i;

    TowStart = ans.Time_TowingStart(:);
    ReadyTow = ans.Time_ReadyForTowing(:);
    WaitTow = TowStart - ReadyTow;
    WaitTowTot(i) = sum(WaitTow);
    WaitForTow(i) = sum(WaitTow)/i;

    InstallStart = ans.Time_InstallationStart(:);
    ReadyInstall = ans.Time_ReadyInstall(:);
    WaitInstall = InstallStart - ReadyInstall;
    WaitInstallTot(i) = sum(WaitInstall);
    WaitForInstall(i) = sum(WaitInstall)/i;
    
    AnchorStart = ans.Time_AnchorStart(:);
    ReadyAnchor = ans.Time_ReadyForAnchors(:);
    WaitAnchor = AnchorStart - ReadyAnchor;
    WaitAnchorTot(i) = sum(WaitAnchor);
    WaitForAnchor(i) = sum(WaitAnchor)/i;
    
    CableStart = ans.Time_CableStart(:);
    ReadyCable = ans.Time_ReadyForCable(:);
    WaitCable = CableStart - ReadyCable;
    WaitCableTot(i) = sum(WaitCable);
    WaitForCable(i) = sum(WaitCable)/i;
    
    
    TotWaiting(i) = sum(WaitLift) + sum(WaitTow) + sum(WaitInstall) + sum(WaitAnchor) + sum(WaitCable); 
    
    
    
    %AVERAGE WAITING TIME FOR TURBINE NUMBER

end

AvgTotCostTugs = mean(TotCostTugs,2);
AvgTotCostHLV = mean(TotCostHLV,2);
AvgTotCostAHTS = mean(TotCostAHTS,2);
AvgTotCostCLV = mean(TotCostCLV,2);

AvgFixCostTugs = mean(FixCostTugs);
AvgVarCostTugs = mean(VarCostTugs);
AvgFixCostHLV = mean(FixCostHLV);
AvgVarCostHLV = mean(VarCostHLV);
AvgFixCostAHTS =  mean(FixCostAHTS);
AvgVarCostAHTS = mean(VarCostAHTS);
AvgFixCostCLV =  mean(FixCostCLV);
AvgVarCostCLV = mean(VarCostCLV);
%%%%%


WaitOpList = [1 2 3 4 5];
AvgWaitingList = [sum(WaitLiftTot)/sum(1:1:(length(SetNumberOfTurbines))) ...
    sum(WaitTowTot)/sum(1:1:(length(SetNumberOfTurbines)))...
    sum(WaitInstallTot)/sum(1:1:(length(SetNumberOfTurbines)))...
    sum(WaitAnchorTot)/sum(1:1:(length(SetNumberOfTurbines)))...
    sum(WaitCableTot)/sum(1:1:(length(SetNumberOfTurbines)))];

%%%%%
figure(1)
plot(SetNumberOfTurbines,Cost)
title('Total costs of vessels used')
xlabel('Number of turbines') 
ylabel('Costs in 1,000 EUR')

figure(2)
plot(SetNumberOfTurbines,ScaleOfEconomy)
title('Cost per turbine')
xlabel('Number of turbines') 
ylabel('Costs in 1,000 EUR') 

figure(3)
plot(SetNumberOfTurbines,TimePerTurbineList)
title('Time per turbine')
xlabel('Number of turbines') 
ylabel('Time [h]') 

figure(4)
subplot(2,1,1)
hold on
plot(AvgTotCostTugs)
plot(AvgTotCostHLV)
plot(AvgTotCostAHTS)
plot(AvgTotCostCLV)
legend('Cost Tugs','Cost HLV','Cost AHTS', 'Cost CLV')
title('Total costs of vessels used')
xlabel('Time')
ylabel('Costs in 1,000 EUR')
hold off
subplot(2,1,2)
x = categorical({'Tugs','HLV','AHTS', 'CLV'});
x = reordercats(x,{'Tugs','HLV','AHTS','CLV'});
y = [AvgFixCostTugs AvgVarCostTugs; AvgFixCostHLV AvgVarCostHLV; ...
    AvgFixCostAHTS AvgVarCostAHTS; AvgFixCostCLV AvgVarCostCLV];
bar(x,y,'stacked')
xlabel('Vessel type');
ylabel('Costs in 1,000 EUR');

figure(5)
bar(SetNumberOfTurbines,WaitForLift)
for i1=1:numel(WaitForLift)
    text(SetNumberOfTurbines(i1),WaitForLift(i1),num2str(WaitForLift(i1),'%0.0f'),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom')
end
title('Waiting for weather-window before mating operation')
xlabel('Number of turbines') 
ylabel('Waiting time per turbine [h]')  

figure(6)
bar(SetNumberOfTurbines,WaitForTow)
for i1=1:numel(WaitForTow)
    text(SetNumberOfTurbines(i1),WaitForTow(i1),num2str(WaitForTow(i1),'%0.0f'),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom')
end
title('Waiting for weather-window before towing operation per turbine')
xlabel('Number of turbines') 
ylabel('Waiting time per turbine [h]')  

figure(7)
bar(SetNumberOfTurbines,WaitForInstall)
for i1=1:numel(WaitForInstall)
    text(SetNumberOfTurbines(i1),WaitForInstall(i1),num2str(WaitForInstall(i1),'%0.0f'),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom')
end
title('Waiting for weather-window before hook-up operation')
xlabel('Number of turbines') 
ylabel('Waiting time per turbine [h]')

figure(8)
bar(SetNumberOfTurbines,WaitForAnchor)
for i1=1:numel(WaitForAnchor)
    text(SetNumberOfTurbines(i1),WaitForAnchor(i1),num2str(WaitForAnchor(i1),'%0.0f'),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom')
end
title('Waiting for weather-window before anchor & mooring line operation')
xlabel('Number of turbines') 
ylabel('Waiting time per turbine [h]')

figure(9)
bar(SetNumberOfTurbines,WaitForCable)
for i1=1:numel(WaitForCable)
    text(SetNumberOfTurbines(i1),WaitForCable(i1),num2str(WaitForCable(i1),'%0.0f'),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom')
end
title('Waiting for weather-window before cable laying operation')
xlabel('Number of turbines') 
ylabel('Waiting time per turbine [h]')

figure(10)
bar(SetNumberOfTurbines,TotWaiting)
for i1=1:numel(TotWaiting)
    text(SetNumberOfTurbines(i1),TotWaiting(i1),num2str(TotWaiting(i1),'%0.0f'),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom')
end
title('Total waiting for weather-window')
xlabel('Number of turbines') 
ylabel('Waiting time [h]')

figure(13)
plot(ans.SeaStatesGulen)
title('Sea States Gulen')
xlabel('Time') 
ylabel('Significant wave height [m]') 

figure(14)
plot(Wind_G)
title('Wind Speeds Gulen')
xlabel('Time') 
ylabel('Velocity of wind [m/s]') 

figure(15)
plot(ans.AmountTurbines)
title('Amount of turbines assembled')
xlabel('Time') 
ylabel('Amount of turbines')

figure(15)
plot(ans.AmountTurbines)
title('Amount of turbines assembled')
xlabel('Time') 
ylabel('Amount of turbines') 

figure(16)
plot(ans.SeaStatesTampen)
title('Sea States Tampen')
xlabel('Time') 
ylabel('Significant wave height [m]') 

figure(17)
plot(Wind_T)
title('Wind Speeds Tampen')
xlabel('Time') 
ylabel('Velocity of wind [m/s]') 

figure(18)
plot(ans.AmountInstalled)
title('Amount floating wind turbines installed on site')
xlabel('Time') 
ylabel('Amount wind turbines')  

figure(19)
bar(WaitOpList,AvgWaitingList)
for i1=1:numel(AvgWaitingList)
    text(WaitOpList(i1),AvgWaitingList(i1),num2str(AvgWaitingList(i1),'%0.0f'),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom')
end
title('Average waiting time per turbine for different operations')
xlabel('Operation') 
ylabel('Average waiting time per turbine [h]')
ax = gca;
ax.XTick = [1 2 3 4 5];
ax.XTickLabels = {'Mating', 'Towing', 'Hook-Up', 'Anchor & Mooring', 'Cable-Laying'};
ax.XTickLabelRotation = 45;
z.FaceColor = 'flat';
z.CData(1,:) = [1,1,0];
z.CData(2,:) =  [1,1,0];
z.CData(3,:) =	[1,1,0];
z.CData(4,:) =	[1,1,0];
z.CData(5,:) =	[1,1,0];

%Calculating the waiting time
%LiftStart = ans.Time_LiftingStart(:);
%ReadyLift = ans.Time_ReadyForLifting(:);
%WaitLift = LiftStart - ReadyLift;

%TowStart = ans.Time_TowingStart(:);
%ReadyTow = ans.Time_ReadyForTowing(:);
%WaitTow = TowStart - ReadyTow;

%InstallStart = ans.Time_InstallationStart(:);
%ReadyInstall = ans.Time_TowingFinished(:);
%WaitInstall = InstallStart - ReadyInstall;

 %CableStart = ans.Time_CableStart(:);
 %ReadyCable = ans.Time_ReadyForCable(:);
 %WaitCable = CableStart - ReadyCable;
   

%figure(19)
%bar(WaitLift)
%title('Waiting for weather-window before lifting operation')
%xlabel('Wind Turbine nr.') 
%ylabel('Waiting time [h]')  

%figure(20)
%bar(WaitTow)
%title('Waiting for weather-window before towing operation')
%xlabel('Wind turbine nr.') 
%ylabel('Waiting time [h]')  

%figure(21)
%bar(WaitInstall)
%title('Waiting for weather-window before final install operation')
%xlabel('Wind turbine nr.') 
%ylabel('Waiting time [h]')  

%figure(22)
%bar(WaitCable)
%title('Waiting for weather-window before cable laying operation')
%xlabel('Wind turbine nr.') 
%ylabel('Waiting time [h]')  
